"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AItem_1 = require("./AItem");
const MqttDispatcher_1 = require("./MqttDispatcher");
class Forwarder extends AItem_1.AItem {
    constructor(floor, room, item, topicLastPart, label, targetTopics) {
        super(floor, room, item, label);
        this.inTopic = `${this.topicFirstPart}/${topicLastPart}`;
        this.subscribeTopics = [this.inTopic];
        this.targetTopics = targetTopics;
    }
    processMessage(topic, payload) {
        switch (topic) {
            case this.inTopic:
                this.targetTopics.forEach((targetTopic) => {
                    MqttDispatcher_1.mqttHandler.send(targetTopic, payload, true);
                });
                break;
        }
    }
}
exports.Forwarder = Forwarder;
//# sourceMappingURL=Forwarder.js.map